
{$OPTIMIZATION OFF}

unit Camera;

interface

uses
   SysUtils, Windows, OpenCV, SyncObjs, iANPR;


  type pCriticalSection = ^TCriticalSection;

  function Start( ip, login, password : string ) : integer;
  procedure Stop;

  function LoadImage_() : HBITMAP;
  function Section_() : pCriticalSection;
  function GetResult( ) : string;
  function GetFps( ) : integer;

  procedure Init();
  procedure Dispose();

  
implementation

uses Math;

var
 bStop    : boolean;
 capture  : pCVCapture;
 bitmap   : HBITMAP;
 cs       : TCriticalSection;

  iCounterPerSec: TLargeInteger;
  C1, C2: TLargeInteger;
  cres: Real;

  all   : Integer;
  Rects : array[0..99] of TCvRect;

  ptext: array of pchar;

  outbuf : string;

  counter : integer;
  fps : integer;



function CreateRGBBitmap( _Grab : pIplImage) : HBITMAP;
var
	bi 			: BITMAPINFO;
	hRetBitmap 	: HBITMAP;
	pBits 		: Pointer;
	App 		: PByte;

	i, j: integer;
	width, height : integer;


begin

    width := _Grab.width;
    height := _Grab.height;

    bi.bmiHeader.biSize         := sizeof(BITMAPINFOHEADER);
    bi.bmiHeader.biWidth        := _Grab.width;
    bi.bmiHeader.biHeight       :=_Grab.height;
    bi.bmiHeader.biPlanes       := 1;
    bi.bmiHeader.biBitCount     := 24;
    bi.bmiHeader.biCompression  := BI_RGB;
    bi.bmiHeader.biSizeImage      := ( Floor(((_Grab.width * 8) + 31) / 32) * 4)  * _Grab.height;
    bi.bmiHeader.biXPelsPerMeter  := 0;
    bi.bmiHeader.biYPelsPerMeter  := 0;
    bi.bmiHeader.biClrUsed        := 0;
    bi.bmiHeader.biClrImportant   := 0;

    hRetBitmap := CreateDIBSection(0, bi, DIB_RGB_COLORS, pBits, 0, 0);

    if (hRetBitmap <> 0) then
    begin
      App := pBits;
      //length := 0;

      if (_Grab.nChannels = 1) then begin  //   
        for i := 0 to _grab.height - 1 do begin
          for j := 0 to _grab.width - 1 do begin
            pByte(integer(App) + width * 3 * (height-i-1) + j * 3)^     := pByte(integer(_Grab.imageData) + width * i + j)^;
            pByte(integer(App) + width * 3 * (height-i-1) + j * 3 + 1)^ := pByte(integer(_Grab.imageData) + width * i + j)^;
            pByte(integer(App) + width * 3 * (height-i-1) + j * 3 + 2)^ := pByte(integer(_Grab.imageData) + width * i + j)^;
          end
        end


      end
      else if (_Grab.nChannels = 3) then begin // 
        for i := 0 to _grab.height - 1 do begin
            CopyMemory(Pointer(integer(App) + width * 3 * (height-i-1)), Pointer(integer(_Grab.imageData) + width*3*i), width * 3);
        end    
      end

    end;
    CreateRGBBitmap := hRetBitmap;
end;

procedure ImageProcess( param : Pointer ) ;
var
  frame 		: pIplImage;
  small_image 	: pIplImage;
  objectImg 	: pIplImage;
  size 			: TcvSize;
  a				: ANPR_OPTIONS;

  s : TCvSize;

  i1 : integer;
  i,j,k,j1 : integer;

  mem : array[0..99,0..19] of char;
	all_mem : integer;

  font : TCvFont;
  aa : real;
  lstr : integer;
  pp2,pp1 :TCvPoint;
  Rect__: TCvRect;

 number : integer;
begin

  a.Detect_Mode 	  := ANPR_DETECTCOMPLEXMODE;
  a.min_plate_size 	:= 500;
  a.max_plate_size 	:= 25000;
  a.max_text_size 	:= 20;
  a.type_number 	  := ANPR_RUSSIAN_BASE2;
  a.flags 			    := 0;

  size.width  := 320;
  size.height := 240;
  small_image := cvCreateImage(size, 8, 3);

  objectImg	  := nil;

  all_mem := 0;

  while true do begin

    if (counter mod 20 = 0) then begin

         if ( iCounterPerSec <> 0) then begin
          QueryPerformanceCounter(C2);
          cres := (C2 - C1) / iCounterPerSec;
          fps :=  round(counter / cres);
         end;

         QueryPerformanceFrequency(iCounterPerSec);
         QueryPerformanceCounter(C1);

         counter := 0;

      end;

    counter := counter + 1;


    frame := cvQueryFrame(capture);
    if (frame = nil) then break;

	  if (objectImg = nil) then
	  begin
        s:= cvGetSize(frame);
        objectImg := cvCreateImage( s, 8, 1 );
        cvZero(objectImg);
        objectImg.origin := frame.origin;
  	end;
    cvCvtColor( frame, objectImg, CV_BGR2GRAY);

    all := 99;

    i1 := -1;
    try
    //QueryPerformanceFrequency(iCounterPerSec);
    //QueryPerformanceCounter(C1);

    //      
    //i1 := anprPlate(objectImg, a, @all, @Rects, @ptext[0]);

    //      (    )
    //    ,      ,      
    Rect__.width := Round(objectImg.width*0.6);
    Rect__.height := Round(objectImg.height *0.5);
    Rect__.x := Round(objectImg.width*0.2);
    Rect__.y := Round(objectImg.height *0.25);
    i1 := anprPlateRect(objectImg, Rect__, a, @all, @Rects, @ptext[0]);
    //  ,   
    cvRectangle(frame, CV_POINT(Rect__.x, Rect__.y),
                      CV_POINT(Rect__.x + Rect__.width, Rect__.y + Rect__.height), CV_RGB(255,0,0), 5);
    //QueryPerformanceCounter(C2);
    //cres := (C2 - C1) / iCounterPerSec;
    except
      ExitProcess(1);
    end;

    number := 0;
    if (i1 = 0) then begin

      for j:=0 to all-1 do begin

        if (StrLen( ptext[j] ) >= 8) then begin

           k := 0;

           for j1:=0 to all_mem-1 do begin

            if (StrComp(ptext[j], mem[j1]) = 0) then k := 1;

            if k = 0 then continue;

            //     
            //cvRectangle(frame, CV_POINT(Rects[j].x, Rects[j].y),
            //          CV_POINT(Rects[j].x + Rects[j].width, Rects[j].y + Rects[j].height), CV_RGB(255,255,0), 2);
            //    
            cvRectangle(frame, CV_POINT(Rects[j].x+Rect__.x, Rects[j].y+Rect__.y),
                      CV_POINT(Rects[j].x + Rects[j].width+Rect__.x, Rects[j].y + Rects[j].height+Rect__.y), CV_RGB(255,255,0), 2);

            aa := 0.001 * frame.width;
            cvInitFont(@font, 0, aa, aa, 0, 1, 8);

            //     
            //pp2.x := Rects[j].x;
				  	//pp2.y := Rects[j].y;
					  //pp1.x := Rects[j].x+1;
				  	//pp1.y := Rects[j].y+1;
            //    
            pp2.x := Rects[j].x+Rect__.x;
				  	pp2.y := Rects[j].y+Rect__.y;
					  pp1.x := Rects[j].x+1+Rect__.x;
				  	pp1.y := Rects[j].y+1+Rect__.y;

            cvPutText(frame, ptext[j], pp1, @font, CV_RGB(0,0,0));
            cvPutText(frame, ptext[j], pp1, @font, CV_RGB(0,255,0));

            if j = 0 then number := 1;

           end;

        end;
      end;

      for j := 0 to all - 1 do begin
        lstr := StrLen(ptext[j]);
        for i := 0 to lstr - 1 do begin
          i1 := i;
          if (ptext[j][i] = '?') then begin
            i1 := -1;
            break;
          end;
        end;

        if (i1 = -1) then continue;

        if (StrLen(ptext[j]) >= 8) then StrCopy(mem[j], ptext[j]);

      end;

      all_mem := all;

    end;

    cvResize(frame, small_image);

    cs.Acquire;
      if (number = 1) then begin
        outbuf := Format('Time and data: %s - Number: %s', [ DateTimeToStr(Now) , ptext[0] ] );
      end
      else outbuf := '';

      if bitmap <> 0 then DeleteObject(bitmap);
      Bitmap := 0;
      bitmap := CreateRGBBitmap(small_image);
    cs.Release;

    QueryPerformanceCounter(C2);
    cres := (C2 - C1) / iCounterPerSec;

    Sleep(2);

    if bStop = true then break;
  end;

  cvReleaseCapture( capture );
  cvReleaseImage(small_image);
  if (objectImg <> nil) then cvReleaseImage(objectImg);


  for i := 0 to all-1 do FreeMem( ptext[i] );
  FreeMem(ptext);

end;


function Start( ip, login, password : string ) : integer;
var
 buf : string;

 lpT : DWORD;
 hThread : THandle;
 i : integer;

begin

  //buf := Format('http://%s:%s@%s/video.cgi?.mjpg', [login, password, IP] );
  buf := Format('http://%s:%s@%s/mjpg/video.mjpg', [login, password, IP] );

  capture := cvCreateFileCapture(pansichar(buf));
  //capture := cvCreateCameraCapture( 0 );
  

  if (capture = nil) then begin
    Result := 1;
    exit;
  end;

  bStop := false;



  all := 100;

  counter := 0;

  GetMem( ptext, all * sizeof(pchar));
  for i := 0 to all-1 do GetMem( ptext[i], 20 *sizeof( char ) );

  hThread := CreateThread(nil, 0, @ImageProcess, nil, 0, lpT );

  Result := 0;
end;


procedure Stop;
begin
  bStop := true;
end;

function LoadImage_() : HBITMAP;
begin
	LoadImage_ := Bitmap;
end;

function Section_() : pCriticalSection;
begin
	Section_ := @cs;
end;

function GetResult( ) : string;
begin
  Result := outbuf;
end;

function GetFps( ) : integer;
begin
  Result := fps;
end;

procedure Init();
begin
   cs := TCriticalSection.Create;
end;

procedure Dispose();
begin
   cs.Free;
end;

end.
